/*
** EPITECH PROJECT, 2020
** R-Type
** File description:
** Exceptions
*/

#ifndef __EXCEPTIONS_HPP_
#define __EXCEPTIONS_HPP_

#include <exception>
#include <string>

namespace client {

    class Exception : public std::exception {
        public:
            Exception(const std::string &message);
            ~Exception() override = default;
            Exception(const Exception &) = default;
            Exception &operator=(const Exception &) = default;

            [[nodiscard]] const char *what() const noexcept override;

        private:
            std::string _message;
    };

    class ClientException: public Exception {
        public:
            ClientException(const std::string &message);
    };

    class ServerException : public Exception {
        public:
            explicit ServerException(const std::string &message);
            ~ServerException() override = default;
    };

    class GameException : public Exception {
        public:
            explicit GameException(const std::string &message);
            ~GameException() override = default;
    };
}

#endif // __EXCEPTIONS_HPP_
