//
// Created by mockie on 30/01/2021.
//

#ifndef GGJ_2021_MAPGENERATOR_H
#define GGJ_2021_MAPGENERATOR_H

#include "debug.h"
#include "MapGraph.h"
#include "Isle.h"
#include <random>

class MapGenerator {
public:
    void  Generate(MapGraph& graph, int seed) ;
#ifdef DEBUG
    void testMap(MapGraph& graph);
#endif
    class Point{
    public:
        Point(int _x, int _y):coordinates(_x, _y){};
        Vector2i coordinates;
        Isle isle;
    };

    class Edge{
    public:
        Edge(Point *_p1, Point *_p2):p1(_p1), p2(_p2){};
        Point* p1;
        Point* p2;
    };


private:
    void follow(const Direction &d, Point &origin, const int &length);
    Point& spread(Point &position, const Direction &origin, const int& length);
    void ajustPosition(Point &point, const Direction &direction, const Isle::Size &isleSize);
    void clean();
    MapGraph result;

    int randBridge();
    Isle randIsle();
    std::vector<Direction> randSpread(const Direction & origin, const int & count);
    int randInitializer(int seed);
    Point translate(const Point &object, const Direction& d, const int& length);
    Direction oppositeDirection(const Direction& d);

    std::vector<Point> points;
    std::vector<Edge> edges;

    std::vector<Isle::Biome> probaBiomes;
    std::vector<Isle::Size> probaSize;
    std::vector<int> probaBridgeLength;
    std::vector<int> probaSpread;

    std::minstd_rand generator;



};


#endif //GGJ_2021_MAPGENERATOR_H
