//
// Created by mockie on 30/01/2021.
//

#ifndef GGJ_2021_MAPGRAPH_H
#define GGJ_2021_MAPGRAPH_H

#include <vector>
#include <memory>
#include "utilities.h"
#include "Isle.h"

class MapGraph {

public:

    class Edge{
    public:
        Edge(Orientation ori, Color col, int siz, Isle* i1, Isle* i2):
            orientation(ori), color(col), size(siz), node1(i1), node2(i2){};
        Orientation orientation;
        Color color;
        int size;
        Isle* node1;
        Isle* node2;
    };

public:

    Isle* add_isle(Isle& isle);
    void link(Isle* isle1, Isle* isle2);

    const std::vector<Isle>& Isles(){return _isles;};
    const std::vector<Edge>& Edges(){return _edges;};

protected:
    std::vector<Isle> _isles; //This Vector have to always be sorter up tu down
    std::vector<Edge> _edges;

};


#endif //GGJ_2021_MAPGRAPH_H
