/*
** EPITECH PROJECT, 2020
** B-CPP-501-NAN-5-1-rtype-amaury.lecomte
** File description:
** Game
*/

#ifndef R_TYPE_SERVER_GAME_HPP
#define R_TYPE_SERVER_GAME_HPP

#include "IGame.hpp"
#include "Exceptions.hpp"

class Game : public IGame {
public:
    Game(std::shared_ptr<network::ISocket> &, bool debug);
    ~Game() override = default;
    Game(const Game &) = delete;
    Game &operator=(const Game &) = delete;

    /* PLAYER */
    bool addPlayer(Client &) override;
    bool removePlayer(Client &) override;
    [[nodiscard]] const std::vector<std::reference_wrapper<Client>> &getPlayers() const noexcept override;

    /* CONTROL */
    void start() override;
    void addClientData(int idClient, std::string buffer) override;

    /* GETTER/SETTER */
    [[nodiscard]] bool isStart() const noexcept override;


private:
    std::weak_ptr<network::ISocket> _socketUDP;
    bool _isStart;
    std::vector<std::reference_wrapper<Client>> _clients;
    bool _debug;
};

#endif //R_TYPE_SERVER_GAME_HPP
