//
// Created by mockie on 30/01/2021.
//

#ifndef GGJ_2021_UTILITIES_H
#define GGJ_2021_UTILITIES_H

template <class T, class U>
class Pair
{
public:
    Pair(T _x, U _y) : x(_x), y(_y) {};
    Pair(const Pair<T,U>& _p) :  x(_p.x), y(_p.y){};
    T x;
    U y;
};

template <class T>
using Vector2 = Pair<T,T>;

using Vector2f = Vector2<float>;
using Vector2i = Vector2<int>;

enum Orientation{
    VERTICAL,
    HORIZONTAL,
    TOPDOWN,
    DOWNTOP
};

enum Direction{
    NORTH       = 0x00000001,
    SOUTH       = 0x00000010,
    EAST        = 0x00000100,
    WEST        = 0x00001000,
    NORTHEAST   = 0x00010000,
    NORTHWEST   = 0x00100000,
    SOUTHEAST   = 0x01000000,
    SOUTHWEST   = 0x10000000
};

enum Color{
    RED     = 0x00000001,
    BLUE    = 0x00000010,
    YELLOW  = 0x00000100,
    GREEN   = 0x00001000,
    GRAY    = 0x00000000
};



#endif //GGJ_2021_UTILITIES_H
