/*
** EPITECH PROJECT, 2020
** R-Type
** File description:
** Exceptions
*/

#include "Exceptions.hpp"

using namespace client;

Exception::Exception(const std::string &message) : _message(message)
{
}

const char *Exception::what() const noexcept
{
    return (_message.c_str());
}

ClientException::ClientException(const std::string &message):
    Exception(message)
{}

ServerException::ServerException(const std::string &message) : Exception("[Server] : " + message)
{
}

GameException::GameException(const std::string &message) : Exception("[Game] : " + message)
{

}
