//
// Created by mockie on 30/01/2021.
//

#include "GameManager.h"

GameManager::GameManager() {
}


void GameManager::initialize() {
    this->_gm.init("config/");
    _player = new Player(&_gm, 100, 20, PlayerColor::RED);
    _land = new Land(&_gm, 100, 20);
    _colliderMap = new ColliderMap(&_gm, _player, _land);
}
const fileParser::AnimData &GameManager::getAnimation(const std::string &name) {
    auto it = std::find_if(this->_gm._animations.begin(), this->_gm._animations.end(), [&name](const fileParser::AnimData &anim) {
        return anim.animTitle == name;
    });
    if (it == this->_gm._animations.end())
        printf("Animation not found");
    return *it;
}

void GameManager::run() {
    float elapsed = this->_gm._graphical._sm.getGlobalClockElapsedTime();
    if (elapsed >= 0.01667) {
        this->_gm._graphical._sm.restartGlobalClock();
        _land->draw();
        _player->move();
        _colliderMap->dontletthemfall();
        _player->draw();
        this->_gm.render();
    }
}
