/*
 * @name LostSeekers
 *
 * @description Entry File For LostSeekers. LostSeekers is a game developed initially during the Global Game Jam Online in 2020 \
 * It is a multiplayer puzzle game where 4 players are lost on an archipel of flying islands, and intend to find each other.
 * However, during this Trial, traps and obstacles will apear to harden their path. Will they find their friends, or Death ?
 *
 * @function main
 *
 *
 * Created by MockingSpark on 30/01/2021.
*/

#include "moduleMap/debug.h"

//#define SERVER
#define CLIENT

#ifdef DEBUG
#include <iostream>
#endif

#ifdef CLIENT
#include "GameManager.h"
#include "moduleMap/Map.h"
#endif

#ifdef SERVER
#include "server/ServerManager.hpp"
#endif

int main(int argc, char** argv)
{
#ifdef DEBUG
    std::cout << "Game started" << std::endl;
#endif


#ifdef CLIENT
    GameManager game;

    Map m;
    m.generate(2);


    game.initialize();
    while(1) {
        game.run();
    }
    game.close();

    return EXIT_SUCCESS;

#endif
#ifdef SERVER
    try {
        ServerManager game(argc, argv);
        game.initialize();
        game.run();
        game.close();
    } catch(const std::exception& e) {
        std::cerr << e.what() << std::endl;
        return 84;
    }

    return EXIT_SUCCESS;

#endif


}
