//
// Created by Quequ'un on ojourdoui.
//

#include "moduleGameLogic/Land.h"

Land::Land(GraphicsManager* gm, float x, float y)
    : _gm(gm)
{
    _spriteId = _gm->_graphical._sm.addSprite(getAnimation("S_top_fairy"));
    _gm->_graphical._sm.getSprite(_spriteId).setPosition(x, y);
}
const fileParser::AnimData& Land::getAnimation(const std::string& name) {
    auto it = std::find_if(_gm->_animations.begin(), _gm->_animations.end(), [&name](const fileParser::AnimData& anim) {
        return anim.animTitle == name;
        });
    if (it == _gm->_animations.end())
        printf("Animation not found");
    return *it;
}

void Land::draw() {
    _gm->_graphical.draw(_gm->_graphical._sm.getSprite(_spriteId));
}
