//
// Created by Quequ'un on ojourdoui.
//

#include "moduleGameLogic/Player.h"

Player::Player(GraphicsManager *gm, float x, float y, PlayerColor color)
    : _gm(gm)
{
    _currentAnimation = "Down";
    _spriteId = _gm->_graphical._sm.addSprite(getAnimation("Down"));
    _gm->_graphical._sm.getSprite(_spriteId).setPosition(x, y);
}
const fileParser::AnimData& Player::getAnimation(const std::string& name) {
    auto it = std::find_if(_gm->_animations.begin(), _gm->_animations.end(), [&name](const fileParser::AnimData& anim) {
        return anim.animTitle == name;
        });
    if (it == _gm->_animations.end())
        printf("Animation not found");
    return *it;
}

void Player::draw() {
    _gm->_graphical.draw(_gm->_graphical._sm.getSprite(_spriteId));
}

void Player::move() {
    _lastXPosition = _gm->_graphical._sm.getSprite(_spriteId).getPosition().x;
    _lastYPosition = _gm->_graphical._sm.getSprite(_spriteId).getPosition().y;
    if (_gm->_graphical._kbm.getKeyStates()[UP]) {
        if ("Up" != _currentAnimation) {
            _gm->_graphical._sm.getSprite(_spriteId).setAnimation(getAnimation("Up"));
            _currentAnimation = "Up";
            std::cout << "Up" << std::endl;
        }
        _gm->_graphical._sm.moveSprite(_spriteId, 0, -1);
    }
    if (_gm->_graphical._kbm.getKeyStates()[DOWN]) {
        if ("Down" != _currentAnimation) {
            _gm->_graphical._sm.getSprite(_spriteId).setAnimation(getAnimation("Down"));
            _currentAnimation = "Down";
            std::cout << "Down" << std::endl;
        }
        _gm->_graphical._sm.moveSprite(_spriteId, 0, 1);
    }
    if (_gm->_graphical._kbm.getKeyStates()[LEFT])
        _gm->_graphical._sm.moveSprite(_spriteId, -1, 0);
    if (_gm->_graphical._kbm.getKeyStates()[RIGHT])
        _gm->_graphical._sm.moveSprite(_spriteId, 1, 0);
}

std::vector<sf::Vector2f> Player::getCorners() const {
    sf::Vector2f pos = _gm->_graphical._sm.getSprite(_spriteId).getPosition();
    return {
        { pos.x, pos.y },
        { pos.x + 16, pos.y},
        { pos.x, pos.y + 32},
        { pos.x + 16, pos.y + 32}};
}
