//
// Created by mockie on 30/01/2021.
//

#include "moduleGraphics/GraphicsManager.h"

GraphicsManager::GraphicsManager() : _graphical(1920, 1080, "ggj2021")
{
}

void GraphicsManager::init(const std::string &path) {
    fileParser::FileParserManager parser;
    std::vector<fileParser::DisplayableEntityInfo> configs = parser.loadConfigFiles(ASSETS_PATH + path);
    for (auto &file: configs) {
        _animations.insert(_animations.end(), file.animations.begin(), file.animations.end());
    }
    std::cout << "Animations loaded: " << _animations.size() << std::endl;
    for (auto &anim: _animations) {
        std::cout << anim.animTitle << ": " << anim.animId << std::endl;
    }
}
