//
// Created by mockie on 30/01/2021.
//

#include "moduleMap/MapGenerator.h"

#ifdef DEBUG
#include <iostream>
#endif

void MapGenerator::Generate(MapGraph &graph, int seed) {


    // TODO un vrai algo de génération






    /* un point. De ce point partent n traits. Chaque trait avance, et a de plus en plus de chances de générer un autre point
     * Ces nouveaux points ont eux aussi m traits qui en partent.
     * On se donne une condition de fin (poids pour limiter la distance ? profondeur pour limiter les iles successives ?)
     * Une fois la génération finie, on détecte les intersections.
     * Chaque itersection deviens un point avec 4 ponts
     * On fait le ménage en cas de points trop proches ou de pont trop proche d'un point, puis d'îles isolées.
     *
     * On construit ensuite les vecteurs d'îles et ponts et win !
     *
    */

    Point p(0,0);
    p.isle = randIsle();

    points.emplace_back(p);

    //Point* firstPoint = &*(points.end());

    spread(*(points.end()), NORTH, 0);

}

#ifdef DEBUG
void MapGenerator::testMap(MapGraph &graph) {
    Isle i1;
    i1.set(Vector2f(50.,10.),Isle::SMALL,Isle::LARGE,Isle::Bonbon );
    Isle i2;
    i2.set(Vector2f(50.,30.),Isle::LARGE, Isle::MEDIUM, Isle::Lave);
    Isle i3;
    i3.set(Vector2f(10.,70.), Isle::LARGE, Isle::LARGE, Isle::Roche);
    Isle i4;
    i4.set(Vector2f(80.,30.), Isle::MEDIUM, Isle::LARGE, Isle::Neige);

    graph.add_isle(i1);
    graph.add_isle(i2);
    graph.add_isle(i3);
    graph.add_isle(i4);

    graph.link(&i1,&i2);
    graph.link(&i3,&i2);
    graph.link(&i4,&i2);

}
#endif

void MapGenerator::follow(const Direction &d, Point &origin, const int &length) {

//tirer n entre 2 et 6,
// faire un trait de longueur n

// TODO Si on intersecte, placer un point à l'intersection, et recommencer (changement de direction ?)
// Sinon
// placer le point
// spread

    int l = randBridge();
    Point newPoint = translate(origin, d, l);


    Isle i = randIsle();

    newPoint.isle.set(i.position, i.IsleSize(), i.BottomSize(), i.IsleBiome());

    ajustPosition(newPoint, d, newPoint.isle.IsleSize());
    ajustPosition(origin, d, newPoint.isle.IsleSize());

    points.emplace_back(spread(newPoint, oppositeDirection(d), length + l));

    auto p = &*(points.end());

    edges.emplace_back(Edge(&origin,p));


}

MapGenerator::Point& MapGenerator::spread(Point &position, const Direction &origin, const int &length) {

    // tirer pour chaque direction si elle s'étend ou non
    // follow


    if(length < 100)
    {
        int r = generator() % probaSpread.size();
        auto spreadDirections = randSpread(origin, probaSpread[r]);

        for (auto d : spreadDirections)
        {
            follow(d, position, length);
        }
    }


    return position;

}


void MapGenerator::ajustPosition(Point &point, const Direction &direction, const Isle::Size &isleSize) {
    switch (isleSize){
        case Isle::LARGE:
            switch (direction) {
                case NORTH:
                    point.coordinates = Vector2i(point.coordinates.x, point.coordinates.y - 11);
                    break;
                case SOUTH:
                    point.coordinates = Vector2i(point.coordinates.x, point.coordinates.y + 11);
                    break;
                case EAST:
                    point.coordinates = Vector2i(point.coordinates.x + 11, point.coordinates.y );
                    break;
                case WEST:
                    point.coordinates = Vector2i(point.coordinates.x - 11, point.coordinates.y );
                    break;
                case NORTHEAST:
                    point.coordinates = Vector2i(point.coordinates.x + 8, point.coordinates.y - 8);
                    break;
                case NORTHWEST:
                    point.coordinates = Vector2i(point.coordinates.x - 8, point.coordinates.y - 8);
                    break;
                case SOUTHEAST:
                    point.coordinates = Vector2i(point.coordinates.x + 8, point.coordinates.y + 8);
                    break;
                case SOUTHWEST:
                    point.coordinates = Vector2i(point.coordinates.x - 8, point.coordinates.y + 8);
                    break;
            }
            break;
        case Isle::MEDIUM:
            switch (direction) {
                case NORTH:
                    point.coordinates = Vector2i(point.coordinates.x, point.coordinates.y - 8);
                    break;
                case SOUTH:
                    point.coordinates = Vector2i(point.coordinates.x, point.coordinates.y + 8);
                    break;
                case EAST:
                    point.coordinates = Vector2i(point.coordinates.x + 8, point.coordinates.y );
                    break;
                case WEST:
                    point.coordinates = Vector2i(point.coordinates.x - 8, point.coordinates.y );
                    break;
                case NORTHEAST:
                    point.coordinates = Vector2i(point.coordinates.x + 6, point.coordinates.y - 6);
                    break;
                case NORTHWEST:
                    point.coordinates = Vector2i(point.coordinates.x - 6, point.coordinates.y - 6);
                    break;
                case SOUTHEAST:
                    point.coordinates = Vector2i(point.coordinates.x + 6, point.coordinates.y + 6);
                    break;
                case SOUTHWEST:
                    point.coordinates = Vector2i(point.coordinates.x - 6, point.coordinates.y + 6);
                    break;
            }
            break;
        case Isle::SMALL:
            switch (direction) {
                case NORTH:
                    point.coordinates = Vector2i(point.coordinates.x, point.coordinates.y - 5);
                    break;
                case SOUTH:
                    point.coordinates = Vector2i(point.coordinates.x, point.coordinates.y + 5);
                    break;
                case EAST:
                    point.coordinates = Vector2i(point.coordinates.x + 5, point.coordinates.y );
                    break;
                case WEST:
                    point.coordinates = Vector2i(point.coordinates.x - 5, point.coordinates.y );
                    break;
                case NORTHEAST:
                    point.coordinates = Vector2i(point.coordinates.x + 4, point.coordinates.y - 4);
                    break;
                case NORTHWEST:
                    point.coordinates = Vector2i(point.coordinates.x - 4, point.coordinates.y - 4);
                    break;
                case SOUTHEAST:
                    point.coordinates = Vector2i(point.coordinates.x + 4, point.coordinates.y + 4);
                    break;
                case SOUTHWEST:
                    point.coordinates = Vector2i(point.coordinates.x - 4, point.coordinates.y + 4);
                    break;
            }
            break;
    }
}

void MapGenerator::clean() {

        // chercher les intersections :
        // si possible, ajouter une ile
        // etc...
}

int MapGenerator::randBridge() {

    int r;
    r = generator() % probaBridgeLength.size();

    return probaBridgeLength[r];
}

Isle MapGenerator::randIsle() {

    Isle i;


    int r;

    r = generator() % probaBiomes.size();
    i.SetBiome(probaBiomes[r]);

    r = generator() % probaSize.size();
    i.SetSize(probaSize[r]);

    r = generator() % probaSize.size();
    i.SetBottomSize(probaSize[r]);

    return i;

}

int MapGenerator::randInitializer(int seed) {


    generator.seed(seed);

    probaBiomes.clear();
    probaBiomes.push_back(Isle::Biome::Neige);
    probaBiomes.push_back(Isle::Biome::Roche);
    probaBiomes.push_back(Isle::Biome::Lave);
    probaBiomes.push_back(Isle::Biome::Bonbon);
    probaBiomes.push_back(Isle::Biome::Prairie);

    probaBridgeLength.clear();
    probaBridgeLength.push_back(2);
    probaBridgeLength.push_back(2);
    probaBridgeLength.push_back(2);
    probaBridgeLength.push_back(3);
    probaBridgeLength.push_back(3);
    probaBridgeLength.push_back(3);
    probaBridgeLength.push_back(4);
    probaBridgeLength.push_back(4);
    probaBridgeLength.push_back(5);
    probaBridgeLength.push_back(5);
    probaBridgeLength.push_back(6);

    probaSize.clear();
    probaSize.push_back(Isle::LARGE);
    probaSize.push_back(Isle::MEDIUM);
    probaSize.push_back(Isle::SMALL);

    probaSpread.clear();
    for (int i = 0; i < 100; i++)
    {
        if (i< 10)
            probaSpread.push_back(0);
        else if (i<25)
            probaSpread.push_back(1);
        else if (i<50)
            probaSpread.push_back(2);
        else if (i<65)
            probaSpread.push_back(3);
        else if (i<75)
            probaSpread.push_back(4);
        else if (i<85)
            probaSpread.push_back(5);
        else if (i<95)
            probaSpread.push_back(6);
        else
            probaSpread.push_back(7);
    }

#ifdef DEBUG
     std::cout << "seed entered : " << seed << std::endl;
#endif

    return seed;
}

MapGenerator::Point MapGenerator::translate(const Point &object, const Direction& d, const int& length) {

    switch (d) {
        case NORTH:
            return Point(object.coordinates.x, object.coordinates.y - length);
            break;
        case SOUTH:
            return Point(object.coordinates.x, object.coordinates.y + length);
            break;
        case EAST:
            return Point(object.coordinates.x + length, object.coordinates.y );
            break;
        case WEST:
            return Point(object.coordinates.x - length, object.coordinates.y );
            break;
        case NORTHEAST:
            return Point(object.coordinates.x + length, object.coordinates.y - length);
            break;
        case NORTHWEST:
            return Point(object.coordinates.x - length, object.coordinates.y - length);
            break;
        case SOUTHEAST:
            return Point(object.coordinates.x + length, object.coordinates.y + length);
            break;
        case SOUTHWEST:
            return Point(object.coordinates.x - length, object.coordinates.y + length);
            break;
        default:
            return Point(0,0);
    }


}

Direction MapGenerator::oppositeDirection(const Direction &d) {
    switch (d) {
        case NORTH:
            return SOUTH;
            break;
        case SOUTH:
            return NORTH;
            break;
        case EAST:
            return WEST;
            break;
        case WEST:
            return EAST;
            break;
        case NORTHEAST:
            return SOUTHWEST;
            break;
        case NORTHWEST:
            return SOUTHEAST;
            break;
        case SOUTHEAST:
            return NORTHWEST;
            break;
        case SOUTHWEST:
            return NORTHEAST;
            break;
        default:
            return SOUTH;
    }
}

std::vector<Direction> MapGenerator::randSpread(const Direction &origin, const int & count) {

    std::vector<Direction> result;
    if(origin != NORTH)
        result.push_back(NORTH);
    if(origin != SOUTH)
        result.push_back(SOUTH);
    if(origin != EAST)
        result.push_back(EAST);
    if(origin != WEST)
        result.push_back(WEST);
    if(origin != NORTHEAST)
        result.push_back(NORTHEAST);
    if(origin != NORTHWEST)
        result.push_back(NORTHWEST);
    if(origin != SOUTHEAST)
        result.push_back(SOUTHEAST);
    if(origin != SOUTHWEST)
        result.push_back(SOUTHWEST);

    int count_to_delete = 8 - count -1;
    int r;

    for(;count_to_delete < 1; count_to_delete--)
    {
        r = generator() % result.size();
        result.erase(result.begin() + r);
    }



    return result;
}




