/*
** EPITECH PROJECT, 2020
** B-CPP-501-NAN-5-1-rtype-amaury.lecomte
** File description:
** Game
*/

#include <iostream>
#include "server/Game.hpp"

Game::Game(std::shared_ptr<network::ISocket> &socketUDP, bool debug) :
    _socketUDP(socketUDP),
    _isStart(false),
    _debug(debug)
{
}

bool Game::addPlayer(Client &client)
{
    if (_isStart)
        return false;
    if (_clients.size() > 3)
        return false;
    _clients.emplace_back(client);
    return true;
}

void Game::addClientData(int idClient, std::string buffer)
{
    const auto &it = std::find_if(_clients.begin(), _clients.end(), [&idClient](const std::reference_wrapper<Client> &client) {
        return (idClient == client.get().id);
    });
    it->get().data.push(buffer);
}

bool Game::removePlayer(Client &client)
{
    if (_isStart)
        return false;
    _clients.erase(std::remove_if(_clients.begin(), _clients.end(), [&client](const std::reference_wrapper<Client> &otherClient) {
        return (otherClient.get().id == client.id);
    }), _clients.end());
    return true;
}

const std::vector<std::reference_wrapper<Client>> &Game::getPlayers() const noexcept
{
    return (_clients);
}

bool Game::isStart() const noexcept
{
    return (_isStart);
}

void Game::start()
{
    _isStart = true;

    try {
//        _scene->awake(sharedEntities);
//        _scene->start();
        while (_isStart) {
//            _scene->update();
            if (std::count_if(_clients.begin(), _clients.end(), [] (const std::reference_wrapper<Client> &client) {
                return (client.get().idRoom != -1);
            }) == 0) {
                _isStart = false;
                std::cout << "Stop game : no more players" << std::endl;
            }
        }
//        _scene->stop();
//        _scene->tearDown();
    } catch (const /*Game*/client::Exception &e) {
        throw e;
    }
}