#ifndef R_TYPE_SERVER_ANIMATION_HPP
#define R_TYPE_SERVER_ANIMATION_HPP

#include <SFML/Graphics/Rect.hpp>
#include <SFML/Graphics/Sprite.hpp>
#include <vector>

namespace graphicalEngine {
    struct SpriteFrame {
        sf::IntRect rect;
        double duration;
    };

    class Animation {
        public:
            Animation();
            Animation(const Animation &) = default;
            Animation &operator=(const Animation &) = default;

            void addFrame(SpriteFrame&& frame);

            void update(double elapsed, sf::Sprite &target);

            void loop(bool);
            void pause(bool = true);

            void setDisplayedFrame(size_t frame);

            ~Animation() = default;

        private:
            std::vector<SpriteFrame> _frames;

            double _totalLength;
            double _progress;
            bool _pause = false;
            bool _loop = false;
            size_t _frame = 0;
    };
}

#endif //R_TYPE_SERVER_ANIMATION_HPP
