#include "graphicalEngine/Window.hpp"

#ifndef R_TYPE_SERVER_KEYBOARDMANAGER_HPP
#define R_TYPE_SERVER_KEYBOARDMANAGER_HPP

#include <bitset>

enum KeyboardInputsPressed {
    UP,
    DOWN,
    LEFT,
    RIGHT,
    SPACE,
    X,
    ESCAPE
};

namespace graphicalEngine {
    class KeyboardManager {
    public:
        KeyboardManager(std::weak_ptr<Window> currentWindow) : _window(std::move(currentWindow)) {
        }
        ~KeyboardManager() = default;
        KeyboardManager(const KeyboardManager &) = default;
        KeyboardManager &operator=(const KeyboardManager &) = default;

        void listen();
        void manageKeys();
        void logKeys();
        const std::bitset<ESCAPE+1> &getKeyStates();

    private:
        std::bitset<ESCAPE+1> _keysPressed;
        std::weak_ptr<Window> _window;
    };
}


#endif //R_TYPE_SERVER_KEYBOARDMANAGER_HPP
