#ifndef _GRAPHICAL_TEXTUREDATA_HPP
#define _GRAPHICAL_TEXTUREDATA_HPP

#include <SFML/Graphics/Texture.hpp>
#include <iostream>

namespace graphicalEngine {
class TextureData {
public:
        TextureData() = default;
        explicit TextureData(const std::string& assetFilepath);
        ~TextureData() = default;

        TextureData(const TextureData &) = default;
        TextureData &operator=(const TextureData &) = default;

        void setTexture(const std::string& assetFilepath) {
            this->_texture.loadFromFile(assetFilepath);
        }

        void setTextureRepeating(bool setRepeated) {
            this->_texture.setRepeated(setRepeated);
        }

        bool isTextureRepeating() {
            return (this->_texture.isRepeated());
        }

        sf::Texture& getTextureData() {
            return this->_texture;
        }

private:
    sf::Texture _texture;
    };
}

#endif //_GRAPHICAL_TEXTUREDATA_HPP