/*
** EPITECH PROJECT, 2020
** RType
** File description:
** FontManager
*/

#include "graphicalEngine/FontManager.hpp"
#include "SFML/Graphics/Texture.hpp"

sf::Text graphicalEngine::FontManager::createText(sf::Font &font)
{
    sf::Text text;
    text.setFont(font);
    return text;
}

sf::Font &graphicalEngine::FontManager::getFont(const std::string &filepath)
{
    auto it = _fonts.find(filepath);

    if (it != _fonts.end())
        return it->second;
    _fonts[filepath] = sf::Font();
    _fonts[filepath].loadFromFile(filepath);
    return _fonts.at(filepath);
}
