
#include "graphicalEngine/KeyboardManager.hpp"

void graphicalEngine::KeyboardManager::listen() {
    if (!this->_window.expired()) {
        if (auto sptr = this->_window.lock()) {
            if (sptr->getWindowInstance().hasFocus()) {
                this->manageKeys();
            }
        }
    }
}

void graphicalEngine::KeyboardManager::manageKeys() {
    this->_keysPressed.set(UP, sf::Keyboard::isKeyPressed(sf::Keyboard::Up));
    this->_keysPressed.set(DOWN, sf::Keyboard::isKeyPressed(sf::Keyboard::Down));
    this->_keysPressed.set(LEFT, sf::Keyboard::isKeyPressed(sf::Keyboard::Left));
    this->_keysPressed.set(RIGHT, sf::Keyboard::isKeyPressed(sf::Keyboard::Right));
    this->_keysPressed.set(SPACE, sf::Keyboard::isKeyPressed(sf::Keyboard::Space));
    this->_keysPressed.set(X, sf::Keyboard::isKeyPressed(sf::Keyboard::X));
    this->_keysPressed.set(ESCAPE, sf::Keyboard::isKeyPressed(sf::Keyboard::Escape));
}

const std::bitset<ESCAPE+1> &graphicalEngine::KeyboardManager::getKeyStates() {
    return this->_keysPressed;
}

void graphicalEngine::KeyboardManager::logKeys() {
    if (this->_keysPressed[UP])
        std::cout << "Up !" << std::endl;
    if (this->_keysPressed[DOWN])
        std::cout << "Down !" << std::endl;
    if (this->_keysPressed[LEFT])
        std::cout << "Left !" << std::endl;
    if (this->_keysPressed[RIGHT])
        std::cout << "Right !" << std::endl;
    if (this->_keysPressed[SPACE])
        std::cout << "Fire !" << std::endl;
    if (this->_keysPressed[X])
        std::cout << "Force !" << std::endl;
    if (this->_keysPressed[ESCAPE])
        std::cout << "Start !" << std::endl;
}
