/*
** EPITECH PROJECT, 2020
** RType
** File description:
** Window
*/

#include "graphicalEngine/Window.hpp"
#ifdef _WIN32
#endif

void graphicalEngine::Window::display() {
    if (_window.isOpen())
    {
        eventLoop();
        _window.display();
        _window.clear(sf::Color::Black);
    }
}

void graphicalEngine::Window::draw(const sf::Drawable &drawable)
{
    _window.draw(drawable);
}

void graphicalEngine::Window::draw(const Sprite &sprite)
{
    draw(sprite.getSprite());
}

void graphicalEngine::Window::eventLoop() {
    sf::Event event;
    _textEntered = 0;
    if (_window.pollEvent(event))
    {
        if (event.type == sf::Event::Closed) {
            _window.close();
        } else if (event.type == sf::Event::TextEntered) {
            _textEntered = event.text.unicode;
        }
    }
}

sf::VideoMode graphicalEngine::Window::getRenderWindowSize() const {
    sf::VideoMode size(_window.getSize().x, _window.getSize().y);

    return size;
}

void graphicalEngine::Window::setRenderWindowSize(unsigned int windowWidth, unsigned int windowHeight) {
    sf::Vector2u windowSize(windowWidth, windowHeight);

    if (windowWidth >= 640 && windowHeight >= 480) {
        _window.setSize(windowSize);
    } else {
        std::cout << "RenderWindow size specified might be too small. The minimum is a 16:9 aspect ratio window of 640 * 480." << std::endl;
    }
}

std::string graphicalEngine::Window::getTitle() const {
    return _title;
}

void graphicalEngine::Window::setRenderWindowTitle(const std::string &title) {
        _window.setTitle(title);
        _title = title;
}
