/*
** EPITECH PROJECT, 2020
** B-CPP-500-NAN-5-1-babel-jamil.ettel
** File description:
** Server
*/

#ifndef SERVER_HPP_
#define SERVER_HPP_

#include <boost/asio.hpp>
#include "network/TCPSocket.hpp"
#include "network/IServer.hpp"
#include <boost/bind.hpp>

namespace network
{
    class TCPServer: public IServer {
        public:
            TCPServer(boost::asio::io_context &context, int port);
            ~TCPServer() override;
            TCPServer(const TCPServer &) = delete;
            TCPServer &operator=(const TCPServer &) = delete;

            void setAcceptHandler(const std::function<bool(std::shared_ptr<ISocket> &)> &fct) override;

            void acceptClient() override;
            void run() override;

        private:
            boost::asio::io_context &_context;
            boost::asio::ip::tcp::acceptor _acceptor;

            std::shared_ptr<TCPSocket> _nextSocket;

            std::function<bool(std::shared_ptr<ISocket> &)> _acceptHandler;
    };
} // namespace babel::server

#endif /* !SERVER_HPP_ */
